// Type definitions for @ag-grid-community/core v28.2.1
// Project: https://www.ag-grid.com/
// Definitions by: Niall Crosby <https://github.com/ag-grid/>
import { GridOptions } from '../entities/gridOptions';
import { GridApi } from '../gridApi';
import { ColumnApi } from '../columns/columnApi';
export declare class ComponentUtil {
    static EVENTS: string[];
    static PUBLIC_EVENTS: string[];
    static EXCLUDED_INTERNAL_EVENTS: string[];
    private static EVENT_CALLBACKS;
    static STRING_PROPERTIES: ("domLayout" | "rowClass" | "sideBar" | "clipboardDeliminator" | "clipboardDelimiter" | "colResizeDefault" | "editType" | "quickFilterText" | "overlayLoadingTemplate" | "overlayNoRowsTemplate" | "pivotPanelShow" | "pivotColumnGroupTotals" | "pivotRowTotals" | "groupDisplayType" | "rowGroupPanelShow" | "rowModelType" | "serverSideStoreType" | "rowSelection" | "fillHandleDirection" | "multiSortKey" | "treeDataDisplayType")[];
    static OBJECT_PROPERTIES: ("loadingOverlayComponent" | "noRowsOverlayComponent" | "fullWidthCellRenderer" | "loadingCellRenderer" | "groupRowRenderer" | "detailCellRenderer" | "context" | "isFullWidthCell" | "statusBar" | "sideBar" | "popupParent" | "defaultColDef" | "defaultColGroupDef" | "columnTypes" | "components" | "frameworkComponents" | "defaultCsvExportParams" | "defaultExcelExportParams" | "excelStyles" | "defaultExportParams" | "chartThemes" | "customChartThemes" | "chartThemeOverrides" | "chartToolPanelsDef" | "loadingCellRendererFramework" | "loadingCellRendererParams" | "loadingCellRendererSelector" | "localeText" | "detailCellRendererFramework" | "detailCellRendererParams" | "alignedGrids" | "loadingOverlayComponentFramework" | "loadingOverlayComponentParams" | "noRowsOverlayComponentFramework" | "noRowsOverlayComponentParams" | "aggFuncs" | "rowDragText" | "fullWidthCellRendererFramework" | "fullWidthCellRendererParams" | "autoGroupColumnDef" | "groupRowRendererFramework" | "groupRowRendererParams" | "groupRowInnerRenderer" | "groupRowInnerRendererFramework" | "pinnedTopRowData" | "pinnedBottomRowData" | "datasource" | "serverSideDatasource" | "viewportDatasource" | "sortingOrder" | "icons" | "rowStyle" | "rowClassRules" | "getContextMenuItems" | "getMainMenuItems" | "postProcessPopup" | "processCellForClipboard" | "processHeaderForClipboard" | "processGroupHeaderForClipboard" | "processCellFromClipboard" | "sendToClipboard" | "processDataFromClipboard" | "isExternalFilterPresent" | "doesExternalFilterPass" | "getChartToolbarItems" | "createChartContainer" | "navigateToNextHeader" | "tabToNextHeader" | "navigateToNextCell" | "tabToNextCell" | "suppressKeyboardEvent" | "localeTextFunc" | "getLocaleText" | "getDocument" | "paginationNumberFormatter" | "groupRowAggNodes" | "getGroupRowAgg" | "isGroupOpenByDefault" | "initialGroupOrderComparator" | "defaultGroupOrderComparator" | "processSecondaryColDef" | "processSecondaryColGroupDef" | "processPivotResultColDef" | "processPivotResultColGroupDef" | "getDataPath" | "defaultGroupSortComparator" | "getChildCount" | "getServerSideGroupLevelParams" | "getServerSideStoreParams" | "isServerSideGroupOpenByDefault" | "isApplyServerSideTransaction" | "isServerSideGroup" | "getServerSideGroupKey" | "getBusinessKeyForNode" | "getRowNodeId" | "getRowId" | "processRowPostCreate" | "isRowSelectable" | "isRowMaster" | "fillOperation" | "postSort" | "postSortRows" | "getRowStyle" | "getRowClass" | "getRowHeight" | "isFullWidthRow" | "onToolPanelVisibleChanged" | "onToolPanelSizeChanged" | "onPasteStart" | "onPasteEnd" | "onColumnVisible" | "onColumnPinned" | "onColumnResized" | "onColumnMoved" | "onColumnValueChanged" | "onColumnPivotModeChanged" | "onColumnPivotChanged" | "onColumnGroupOpened" | "onNewColumnsLoaded" | "onGridColumnsChanged" | "onDisplayedColumnsChanged" | "onVirtualColumnsChanged" | "onColumnEverythingChanged" | "onComponentStateChanged" | "onCellValueChanged" | "onCellEditRequest" | "onRowValueChanged" | "onCellEditingStarted" | "onCellEditingStopped" | "onRowEditingStarted" | "onRowEditingStopped" | "onFilterOpened" | "onFilterChanged" | "onFilterModified" | "onChartCreated" | "onChartRangeSelectionChanged" | "onChartOptionsChanged" | "onChartDestroyed" | "onCellKeyDown" | "onCellKeyPress" | "onGridReady" | "onFirstDataRendered" | "onGridSizeChanged" | "onModelUpdated" | "onVirtualRowRemoved" | "onViewportChanged" | "onBodyScroll" | "onBodyScrollEnd" | "onDragStarted" | "onDragStopped" | "onPaginationChanged" | "onRowDragEnter" | "onRowDragMove" | "onRowDragLeave" | "onRowDragEnd" | "onColumnRowGroupChanged" | "onRowGroupOpened" | "onExpandOrCollapseAll" | "onPinnedRowDataChanged" | "onRowDataChanged" | "onRowDataUpdated" | "onAsyncTransactionsFlushed" | "onCellClicked" | "onCellDoubleClicked" | "onCellFocused" | "onCellMouseOver" | "onCellMouseOut" | "onCellMouseDown" | "onRowClicked" | "onRowDoubleClicked" | "onRowSelected" | "onSelectionChanged" | "onCellContextMenu" | "onRangeSelectionChanged" | "onSortChanged" | "onColumnRowGroupChangeRequest" | "onColumnPivotChangeRequest" | "onColumnValueChangeRequest" | "onColumnAggFuncChangeRequest")[];
    static ARRAY_PROPERTIES: ("rowClass" | "sideBar" | "columnDefs" | "components" | "excelStyles" | "chartThemes" | "alignedGrids" | "pinnedTopRowData" | "pinnedBottomRowData" | "rowData" | "sortingOrder")[];
    static NUMBER_PROPERTIES: ("tabIndex" | "headerHeight" | "pivotHeaderHeight" | "groupHeaderHeight" | "pivotGroupHeaderHeight" | "floatingFiltersHeight" | "rowHeight" | "paginationPageSize" | "tooltipShowDelay" | "tooltipHideDelay" | "colWidth" | "minColWidth" | "maxColWidth" | "autoSizePadding" | "undoRedoCellEditingLimit" | "keepDetailRowsCount" | "detailRowHeight" | "rowBuffer" | "cellFlashDelay" | "cellFadeDelay" | "groupDefaultExpanded" | "asyncTransactionWaitMillis" | "batchUpdateWaitMillis" | "cacheOverflowSize" | "infiniteInitialRowCount" | "serverSideInitialRowCount" | "cacheBlockSize" | "maxBlocksInCache" | "maxConcurrentDatasourceRequests" | "blockLoadDebounceMillis" | "viewportRowModelPageSize" | "viewportRowModelBufferSize" | "scrollbarWidth")[];
    static BOOLEAN_PROPERTIES: ("valueCache" | "sideBar" | "suppressContextMenu" | "preventDefaultOnContextMenu" | "allowContextMenuWithControlKey" | "suppressMenuHide" | "enableBrowserTooltips" | "tooltipMouseTrack" | "copyHeadersToClipboard" | "copyGroupHeadersToClipboard" | "suppressCopyRowsToClipboard" | "suppressCopySingleCellRanges" | "suppressLastEmptyLineOnPaste" | "suppressClipboardPaste" | "suppressClipboardApi" | "maintainColumnOrder" | "suppressFieldDotNotation" | "deltaColumnMode" | "applyColumnDefOrder" | "immutableColumns" | "suppressSetColumnStateEvents" | "suppressColumnStateEvents" | "allowDragFromColumnsToolPanel" | "suppressMovableColumns" | "suppressColumnMoveAnimation" | "suppressDragLeaveHidesColumns" | "suppressRowGroupHidesColumns" | "suppressAutoSize" | "skipHeaderOnAutoSize" | "reactUi" | "suppressReactUi" | "singleClickEdit" | "suppressClickEdit" | "readOnlyEdit" | "stopEditingWhenCellsLoseFocus" | "enterMovesDown" | "enterMovesDownAfterEdit" | "enableCellEditingOnBackspace" | "undoRedoCellEditing" | "stopEditingWhenGridLosesFocus" | "suppressCsvExport" | "suppressExcelExport" | "cacheQuickFilter" | "excludeChildrenWhenTreeDataFiltering" | "enableCharts" | "enableChartToolPanelsButton" | "masterDetail" | "keepDetailRows" | "detailRowAutoHeight" | "valueCacheNeverExpires" | "enableCellExpressions" | "suppressParentsInRowNodes" | "suppressTouch" | "suppressFocusAfterRefresh" | "suppressAsyncEvents" | "suppressBrowserResizeObserver" | "suppressPropertyNamesCheck" | "suppressChangeDetection" | "debug" | "suppressLoadingOverlay" | "suppressNoRowsOverlay" | "pagination" | "paginationAutoPageSize" | "paginateChildRows" | "suppressPaginationPanel" | "pivotMode" | "pivotSuppressAutoColumn" | "suppressExpandablePivotGroups" | "functionsReadOnly" | "suppressAggFuncInHeader" | "suppressAggAtRootLevel" | "aggregateOnlyChangedColumns" | "suppressAggFilteredOnly" | "removePivotHeaderRowWhenSingleValueColumn" | "animateRows" | "enableCellChangeFlash" | "allowShowChangeAfterFilter" | "ensureDomOrder" | "enableRtl" | "suppressColumnVirtualisation" | "suppressMaxRenderedRowRestriction" | "suppressRowVirtualisation" | "rowDragManaged" | "suppressRowDrag" | "suppressMoveWhenRowDragging" | "rowDragEntireRow" | "rowDragMultiRow" | "embedFullWidthRows" | "deprecatedEmbedFullWidthRows" | "groupMaintainOrder" | "groupSelectsChildren" | "groupAggFiltering" | "groupIncludeFooter" | "groupIncludeTotalFooter" | "groupSuppressBlankHeader" | "groupSelectsFiltered" | "showOpenedGroup" | "groupRemoveSingleChildren" | "groupRemoveLowestSingleChildren" | "groupHideOpenParents" | "suppressMakeColumnVisibleAfterUnGroup" | "treeData" | "rowGroupPanelSuppressSort" | "groupRowsSticky" | "groupMultiAutoColumn" | "groupUseEntireRow" | "groupSuppressAutoColumn" | "rememberGroupStateWhenNewData" | "immutableData" | "suppressModelUpdateAfterUpdateTransaction" | "deltaRowDataMode" | "serverSideInfiniteScroll" | "purgeClosedRowNodes" | "serverSideSortAllLevels" | "serverSideFilterAllLevels" | "serverSideSortOnServer" | "serverSideFilterOnServer" | "serverSideSortingAlwaysResets" | "serverSideFilteringAlwaysResets" | "suppressEnterpriseResetOnNewColumns" | "alwaysShowHorizontalScroll" | "alwaysShowVerticalScroll" | "debounceVerticalScrollbar" | "suppressHorizontalScroll" | "suppressScrollOnNewData" | "suppressScrollWhenPopupsAreOpen" | "suppressAnimationFrame" | "suppressMiddleClickScrolls" | "suppressPreventDefaultOnMouseWheel" | "rowMultiSelectWithClick" | "suppressRowDeselection" | "suppressRowClickSelection" | "suppressCellSelection" | "suppressCellFocus" | "suppressMultiRangeSelection" | "enableCellTextSelection" | "enableRangeSelection" | "enableRangeHandle" | "enableFillHandle" | "suppressClearOnFillReduction" | "rowDeselection" | "accentedSort" | "unSortIcon" | "suppressMultiSort" | "alwaysMultiSort" | "suppressMaintainUnsortedOrder" | "suppressRowHoverHighlight" | "suppressRowTransform" | "columnHoverHighlight" | "deltaSort" | "angularCompileRows" | "angularCompileFilters" | "functionsPassive" | "enableGroupEdit" | "resetRowDataOnUpdate")[];
    static FUNCTION_PROPERTIES: ("api" | "loadingOverlayComponent" | "noRowsOverlayComponent" | "fullWidthCellRenderer" | "loadingCellRenderer" | "groupRowRenderer" | "detailCellRenderer" | "domLayout" | "tabIndex" | "columnApi" | "context" | "headerHeight" | "pivotHeaderHeight" | "groupHeaderHeight" | "pivotGroupHeaderHeight" | "floatingFiltersHeight" | "valueCache" | "rowHeight" | "paginationPageSize" | "rowClass" | "isFullWidthCell" | "statusBar" | "sideBar" | "suppressContextMenu" | "preventDefaultOnContextMenu" | "allowContextMenuWithControlKey" | "suppressMenuHide" | "enableBrowserTooltips" | "tooltipShowDelay" | "tooltipHideDelay" | "tooltipMouseTrack" | "popupParent" | "copyHeadersToClipboard" | "copyGroupHeadersToClipboard" | "clipboardDeliminator" | "clipboardDelimiter" | "suppressCopyRowsToClipboard" | "suppressCopySingleCellRanges" | "suppressLastEmptyLineOnPaste" | "suppressClipboardPaste" | "suppressClipboardApi" | "columnDefs" | "defaultColDef" | "defaultColGroupDef" | "columnTypes" | "maintainColumnOrder" | "suppressFieldDotNotation" | "deltaColumnMode" | "applyColumnDefOrder" | "immutableColumns" | "suppressSetColumnStateEvents" | "suppressColumnStateEvents" | "colWidth" | "minColWidth" | "maxColWidth" | "allowDragFromColumnsToolPanel" | "suppressMovableColumns" | "suppressColumnMoveAnimation" | "suppressDragLeaveHidesColumns" | "suppressRowGroupHidesColumns" | "colResizeDefault" | "suppressAutoSize" | "autoSizePadding" | "skipHeaderOnAutoSize" | "components" | "frameworkComponents" | "reactUi" | "suppressReactUi" | "editType" | "singleClickEdit" | "suppressClickEdit" | "readOnlyEdit" | "stopEditingWhenCellsLoseFocus" | "enterMovesDown" | "enterMovesDownAfterEdit" | "enableCellEditingOnBackspace" | "undoRedoCellEditing" | "undoRedoCellEditingLimit" | "stopEditingWhenGridLosesFocus" | "defaultCsvExportParams" | "suppressCsvExport" | "defaultExcelExportParams" | "suppressExcelExport" | "excelStyles" | "defaultExportParams" | "quickFilterText" | "cacheQuickFilter" | "excludeChildrenWhenTreeDataFiltering" | "enableCharts" | "chartThemes" | "customChartThemes" | "chartThemeOverrides" | "enableChartToolPanelsButton" | "chartToolPanelsDef" | "loadingCellRendererFramework" | "loadingCellRendererParams" | "loadingCellRendererSelector" | "localeText" | "masterDetail" | "keepDetailRows" | "keepDetailRowsCount" | "detailCellRendererFramework" | "detailCellRendererParams" | "detailRowHeight" | "detailRowAutoHeight" | "alignedGrids" | "rowBuffer" | "valueCacheNeverExpires" | "enableCellExpressions" | "suppressParentsInRowNodes" | "suppressTouch" | "suppressFocusAfterRefresh" | "suppressAsyncEvents" | "suppressBrowserResizeObserver" | "suppressPropertyNamesCheck" | "suppressChangeDetection" | "debug" | "overlayLoadingTemplate" | "loadingOverlayComponentFramework" | "loadingOverlayComponentParams" | "suppressLoadingOverlay" | "overlayNoRowsTemplate" | "noRowsOverlayComponentFramework" | "noRowsOverlayComponentParams" | "suppressNoRowsOverlay" | "pagination" | "paginationAutoPageSize" | "paginateChildRows" | "suppressPaginationPanel" | "pivotMode" | "pivotPanelShow" | "pivotColumnGroupTotals" | "pivotRowTotals" | "pivotSuppressAutoColumn" | "suppressExpandablePivotGroups" | "functionsReadOnly" | "aggFuncs" | "suppressAggFuncInHeader" | "suppressAggAtRootLevel" | "aggregateOnlyChangedColumns" | "suppressAggFilteredOnly" | "removePivotHeaderRowWhenSingleValueColumn" | "animateRows" | "enableCellChangeFlash" | "cellFlashDelay" | "cellFadeDelay" | "allowShowChangeAfterFilter" | "ensureDomOrder" | "enableRtl" | "suppressColumnVirtualisation" | "suppressMaxRenderedRowRestriction" | "suppressRowVirtualisation" | "rowDragManaged" | "suppressRowDrag" | "suppressMoveWhenRowDragging" | "rowDragEntireRow" | "rowDragMultiRow" | "rowDragText" | "fullWidthCellRendererFramework" | "fullWidthCellRendererParams" | "embedFullWidthRows" | "deprecatedEmbedFullWidthRows" | "groupDisplayType" | "groupDefaultExpanded" | "autoGroupColumnDef" | "groupMaintainOrder" | "groupSelectsChildren" | "groupAggFiltering" | "groupIncludeFooter" | "groupIncludeTotalFooter" | "groupSuppressBlankHeader" | "groupSelectsFiltered" | "showOpenedGroup" | "groupRemoveSingleChildren" | "groupRemoveLowestSingleChildren" | "groupHideOpenParents" | "rowGroupPanelShow" | "groupRowRendererFramework" | "groupRowRendererParams" | "suppressMakeColumnVisibleAfterUnGroup" | "treeData" | "rowGroupPanelSuppressSort" | "groupRowsSticky" | "groupRowInnerRenderer" | "groupRowInnerRendererFramework" | "groupMultiAutoColumn" | "groupUseEntireRow" | "groupSuppressAutoColumn" | "rememberGroupStateWhenNewData" | "pinnedTopRowData" | "pinnedBottomRowData" | "rowModelType" | "rowData" | "immutableData" | "asyncTransactionWaitMillis" | "suppressModelUpdateAfterUpdateTransaction" | "deltaRowDataMode" | "batchUpdateWaitMillis" | "datasource" | "cacheOverflowSize" | "infiniteInitialRowCount" | "serverSideInitialRowCount" | "serverSideStoreType" | "serverSideInfiniteScroll" | "cacheBlockSize" | "maxBlocksInCache" | "maxConcurrentDatasourceRequests" | "blockLoadDebounceMillis" | "purgeClosedRowNodes" | "serverSideDatasource" | "serverSideSortAllLevels" | "serverSideFilterAllLevels" | "serverSideSortOnServer" | "serverSideFilterOnServer" | "serverSideSortingAlwaysResets" | "serverSideFilteringAlwaysResets" | "suppressEnterpriseResetOnNewColumns" | "viewportDatasource" | "viewportRowModelPageSize" | "viewportRowModelBufferSize" | "alwaysShowHorizontalScroll" | "alwaysShowVerticalScroll" | "debounceVerticalScrollbar" | "suppressHorizontalScroll" | "suppressScrollOnNewData" | "suppressScrollWhenPopupsAreOpen" | "suppressAnimationFrame" | "suppressMiddleClickScrolls" | "suppressPreventDefaultOnMouseWheel" | "scrollbarWidth" | "rowSelection" | "rowMultiSelectWithClick" | "suppressRowDeselection" | "suppressRowClickSelection" | "suppressCellSelection" | "suppressCellFocus" | "suppressMultiRangeSelection" | "enableCellTextSelection" | "enableRangeSelection" | "enableRangeHandle" | "enableFillHandle" | "fillHandleDirection" | "suppressClearOnFillReduction" | "rowDeselection" | "sortingOrder" | "accentedSort" | "unSortIcon" | "suppressMultiSort" | "alwaysMultiSort" | "multiSortKey" | "suppressMaintainUnsortedOrder" | "icons" | "rowStyle" | "rowClassRules" | "suppressRowHoverHighlight" | "suppressRowTransform" | "columnHoverHighlight" | "deltaSort" | "treeDataDisplayType" | "angularCompileRows" | "angularCompileFilters" | "functionsPassive" | "enableGroupEdit" | "getContextMenuItems" | "getMainMenuItems" | "postProcessPopup" | "processCellForClipboard" | "processHeaderForClipboard" | "processGroupHeaderForClipboard" | "processCellFromClipboard" | "sendToClipboard" | "processDataFromClipboard" | "isExternalFilterPresent" | "doesExternalFilterPass" | "getChartToolbarItems" | "createChartContainer" | "navigateToNextHeader" | "tabToNextHeader" | "navigateToNextCell" | "tabToNextCell" | "suppressKeyboardEvent" | "localeTextFunc" | "getLocaleText" | "getDocument" | "paginationNumberFormatter" | "groupRowAggNodes" | "getGroupRowAgg" | "isGroupOpenByDefault" | "initialGroupOrderComparator" | "defaultGroupOrderComparator" | "processSecondaryColDef" | "processSecondaryColGroupDef" | "processPivotResultColDef" | "processPivotResultColGroupDef" | "getDataPath" | "defaultGroupSortComparator" | "getChildCount" | "getServerSideGroupLevelParams" | "getServerSideStoreParams" | "isServerSideGroupOpenByDefault" | "isApplyServerSideTransaction" | "isServerSideGroup" | "getServerSideGroupKey" | "getBusinessKeyForNode" | "getRowNodeId" | "getRowId" | "resetRowDataOnUpdate" | "processRowPostCreate" | "isRowSelectable" | "isRowMaster" | "fillOperation" | "postSort" | "postSortRows" | "getRowStyle" | "getRowClass" | "getRowHeight" | "isFullWidthRow" | "onToolPanelVisibleChanged" | "onToolPanelSizeChanged" | "onPasteStart" | "onPasteEnd" | "onColumnVisible" | "onColumnPinned" | "onColumnResized" | "onColumnMoved" | "onColumnValueChanged" | "onColumnPivotModeChanged" | "onColumnPivotChanged" | "onColumnGroupOpened" | "onNewColumnsLoaded" | "onGridColumnsChanged" | "onDisplayedColumnsChanged" | "onVirtualColumnsChanged" | "onColumnEverythingChanged" | "onComponentStateChanged" | "onCellValueChanged" | "onCellEditRequest" | "onRowValueChanged" | "onCellEditingStarted" | "onCellEditingStopped" | "onRowEditingStarted" | "onRowEditingStopped" | "onFilterOpened" | "onFilterChanged" | "onFilterModified" | "onChartCreated" | "onChartRangeSelectionChanged" | "onChartOptionsChanged" | "onChartDestroyed" | "onCellKeyDown" | "onCellKeyPress" | "onGridReady" | "onFirstDataRendered" | "onGridSizeChanged" | "onModelUpdated" | "onVirtualRowRemoved" | "onViewportChanged" | "onBodyScroll" | "onBodyScrollEnd" | "onDragStarted" | "onDragStopped" | "onPaginationChanged" | "onRowDragEnter" | "onRowDragMove" | "onRowDragLeave" | "onRowDragEnd" | "onColumnRowGroupChanged" | "onRowGroupOpened" | "onExpandOrCollapseAll" | "onPinnedRowDataChanged" | "onRowDataChanged" | "onRowDataUpdated" | "onAsyncTransactionsFlushed" | "onCellClicked" | "onCellDoubleClicked" | "onCellFocused" | "onCellMouseOver" | "onCellMouseOut" | "onCellMouseDown" | "onRowClicked" | "onRowDoubleClicked" | "onRowSelected" | "onSelectionChanged" | "onCellContextMenu" | "onRangeSelectionChanged" | "onSortChanged" | "onColumnRowGroupChangeRequest" | "onColumnPivotChangeRequest" | "onColumnValueChangeRequest" | "onColumnAggFuncChangeRequest")[];
    static ALL_PROPERTIES: ("api" | "loadingOverlayComponent" | "noRowsOverlayComponent" | "fullWidthCellRenderer" | "loadingCellRenderer" | "groupRowRenderer" | "detailCellRenderer" | "domLayout" | "tabIndex" | "columnApi" | "context" | "headerHeight" | "pivotHeaderHeight" | "groupHeaderHeight" | "pivotGroupHeaderHeight" | "floatingFiltersHeight" | "valueCache" | "rowHeight" | "paginationPageSize" | "rowClass" | "isFullWidthCell" | "statusBar" | "sideBar" | "suppressContextMenu" | "preventDefaultOnContextMenu" | "allowContextMenuWithControlKey" | "suppressMenuHide" | "enableBrowserTooltips" | "tooltipShowDelay" | "tooltipHideDelay" | "tooltipMouseTrack" | "popupParent" | "copyHeadersToClipboard" | "copyGroupHeadersToClipboard" | "clipboardDeliminator" | "clipboardDelimiter" | "suppressCopyRowsToClipboard" | "suppressCopySingleCellRanges" | "suppressLastEmptyLineOnPaste" | "suppressClipboardPaste" | "suppressClipboardApi" | "columnDefs" | "defaultColDef" | "defaultColGroupDef" | "columnTypes" | "maintainColumnOrder" | "suppressFieldDotNotation" | "deltaColumnMode" | "applyColumnDefOrder" | "immutableColumns" | "suppressSetColumnStateEvents" | "suppressColumnStateEvents" | "colWidth" | "minColWidth" | "maxColWidth" | "allowDragFromColumnsToolPanel" | "suppressMovableColumns" | "suppressColumnMoveAnimation" | "suppressDragLeaveHidesColumns" | "suppressRowGroupHidesColumns" | "colResizeDefault" | "suppressAutoSize" | "autoSizePadding" | "skipHeaderOnAutoSize" | "components" | "frameworkComponents" | "reactUi" | "suppressReactUi" | "editType" | "singleClickEdit" | "suppressClickEdit" | "readOnlyEdit" | "stopEditingWhenCellsLoseFocus" | "enterMovesDown" | "enterMovesDownAfterEdit" | "enableCellEditingOnBackspace" | "undoRedoCellEditing" | "undoRedoCellEditingLimit" | "stopEditingWhenGridLosesFocus" | "defaultCsvExportParams" | "suppressCsvExport" | "defaultExcelExportParams" | "suppressExcelExport" | "excelStyles" | "defaultExportParams" | "quickFilterText" | "cacheQuickFilter" | "excludeChildrenWhenTreeDataFiltering" | "enableCharts" | "chartThemes" | "customChartThemes" | "chartThemeOverrides" | "enableChartToolPanelsButton" | "chartToolPanelsDef" | "loadingCellRendererFramework" | "loadingCellRendererParams" | "loadingCellRendererSelector" | "localeText" | "masterDetail" | "keepDetailRows" | "keepDetailRowsCount" | "detailCellRendererFramework" | "detailCellRendererParams" | "detailRowHeight" | "detailRowAutoHeight" | "alignedGrids" | "rowBuffer" | "valueCacheNeverExpires" | "enableCellExpressions" | "suppressParentsInRowNodes" | "suppressTouch" | "suppressFocusAfterRefresh" | "suppressAsyncEvents" | "suppressBrowserResizeObserver" | "suppressPropertyNamesCheck" | "suppressChangeDetection" | "debug" | "overlayLoadingTemplate" | "loadingOverlayComponentFramework" | "loadingOverlayComponentParams" | "suppressLoadingOverlay" | "overlayNoRowsTemplate" | "noRowsOverlayComponentFramework" | "noRowsOverlayComponentParams" | "suppressNoRowsOverlay" | "pagination" | "paginationAutoPageSize" | "paginateChildRows" | "suppressPaginationPanel" | "pivotMode" | "pivotPanelShow" | "pivotColumnGroupTotals" | "pivotRowTotals" | "pivotSuppressAutoColumn" | "suppressExpandablePivotGroups" | "functionsReadOnly" | "aggFuncs" | "suppressAggFuncInHeader" | "suppressAggAtRootLevel" | "aggregateOnlyChangedColumns" | "suppressAggFilteredOnly" | "removePivotHeaderRowWhenSingleValueColumn" | "animateRows" | "enableCellChangeFlash" | "cellFlashDelay" | "cellFadeDelay" | "allowShowChangeAfterFilter" | "ensureDomOrder" | "enableRtl" | "suppressColumnVirtualisation" | "suppressMaxRenderedRowRestriction" | "suppressRowVirtualisation" | "rowDragManaged" | "suppressRowDrag" | "suppressMoveWhenRowDragging" | "rowDragEntireRow" | "rowDragMultiRow" | "rowDragText" | "fullWidthCellRendererFramework" | "fullWidthCellRendererParams" | "embedFullWidthRows" | "deprecatedEmbedFullWidthRows" | "groupDisplayType" | "groupDefaultExpanded" | "autoGroupColumnDef" | "groupMaintainOrder" | "groupSelectsChildren" | "groupAggFiltering" | "groupIncludeFooter" | "groupIncludeTotalFooter" | "groupSuppressBlankHeader" | "groupSelectsFiltered" | "showOpenedGroup" | "groupRemoveSingleChildren" | "groupRemoveLowestSingleChildren" | "groupHideOpenParents" | "rowGroupPanelShow" | "groupRowRendererFramework" | "groupRowRendererParams" | "suppressMakeColumnVisibleAfterUnGroup" | "treeData" | "rowGroupPanelSuppressSort" | "groupRowsSticky" | "groupRowInnerRenderer" | "groupRowInnerRendererFramework" | "groupMultiAutoColumn" | "groupUseEntireRow" | "groupSuppressAutoColumn" | "rememberGroupStateWhenNewData" | "pinnedTopRowData" | "pinnedBottomRowData" | "rowModelType" | "rowData" | "immutableData" | "asyncTransactionWaitMillis" | "suppressModelUpdateAfterUpdateTransaction" | "deltaRowDataMode" | "batchUpdateWaitMillis" | "datasource" | "cacheOverflowSize" | "infiniteInitialRowCount" | "serverSideInitialRowCount" | "serverSideStoreType" | "serverSideInfiniteScroll" | "cacheBlockSize" | "maxBlocksInCache" | "maxConcurrentDatasourceRequests" | "blockLoadDebounceMillis" | "purgeClosedRowNodes" | "serverSideDatasource" | "serverSideSortAllLevels" | "serverSideFilterAllLevels" | "serverSideSortOnServer" | "serverSideFilterOnServer" | "serverSideSortingAlwaysResets" | "serverSideFilteringAlwaysResets" | "suppressEnterpriseResetOnNewColumns" | "viewportDatasource" | "viewportRowModelPageSize" | "viewportRowModelBufferSize" | "alwaysShowHorizontalScroll" | "alwaysShowVerticalScroll" | "debounceVerticalScrollbar" | "suppressHorizontalScroll" | "suppressScrollOnNewData" | "suppressScrollWhenPopupsAreOpen" | "suppressAnimationFrame" | "suppressMiddleClickScrolls" | "suppressPreventDefaultOnMouseWheel" | "scrollbarWidth" | "rowSelection" | "rowMultiSelectWithClick" | "suppressRowDeselection" | "suppressRowClickSelection" | "suppressCellSelection" | "suppressCellFocus" | "suppressMultiRangeSelection" | "enableCellTextSelection" | "enableRangeSelection" | "enableRangeHandle" | "enableFillHandle" | "fillHandleDirection" | "suppressClearOnFillReduction" | "rowDeselection" | "sortingOrder" | "accentedSort" | "unSortIcon" | "suppressMultiSort" | "alwaysMultiSort" | "multiSortKey" | "suppressMaintainUnsortedOrder" | "icons" | "rowStyle" | "rowClassRules" | "suppressRowHoverHighlight" | "suppressRowTransform" | "columnHoverHighlight" | "deltaSort" | "treeDataDisplayType" | "angularCompileRows" | "angularCompileFilters" | "functionsPassive" | "enableGroupEdit" | "getContextMenuItems" | "getMainMenuItems" | "postProcessPopup" | "processCellForClipboard" | "processHeaderForClipboard" | "processGroupHeaderForClipboard" | "processCellFromClipboard" | "sendToClipboard" | "processDataFromClipboard" | "isExternalFilterPresent" | "doesExternalFilterPass" | "getChartToolbarItems" | "createChartContainer" | "navigateToNextHeader" | "tabToNextHeader" | "navigateToNextCell" | "tabToNextCell" | "suppressKeyboardEvent" | "localeTextFunc" | "getLocaleText" | "getDocument" | "paginationNumberFormatter" | "groupRowAggNodes" | "getGroupRowAgg" | "isGroupOpenByDefault" | "initialGroupOrderComparator" | "defaultGroupOrderComparator" | "processSecondaryColDef" | "processSecondaryColGroupDef" | "processPivotResultColDef" | "processPivotResultColGroupDef" | "getDataPath" | "defaultGroupSortComparator" | "getChildCount" | "getServerSideGroupLevelParams" | "getServerSideStoreParams" | "isServerSideGroupOpenByDefault" | "isApplyServerSideTransaction" | "isServerSideGroup" | "getServerSideGroupKey" | "getBusinessKeyForNode" | "getRowNodeId" | "getRowId" | "resetRowDataOnUpdate" | "processRowPostCreate" | "isRowSelectable" | "isRowMaster" | "fillOperation" | "postSort" | "postSortRows" | "getRowStyle" | "getRowClass" | "getRowHeight" | "isFullWidthRow" | "onToolPanelVisibleChanged" | "onToolPanelSizeChanged" | "onPasteStart" | "onPasteEnd" | "onColumnVisible" | "onColumnPinned" | "onColumnResized" | "onColumnMoved" | "onColumnValueChanged" | "onColumnPivotModeChanged" | "onColumnPivotChanged" | "onColumnGroupOpened" | "onNewColumnsLoaded" | "onGridColumnsChanged" | "onDisplayedColumnsChanged" | "onVirtualColumnsChanged" | "onColumnEverythingChanged" | "onComponentStateChanged" | "onCellValueChanged" | "onCellEditRequest" | "onRowValueChanged" | "onCellEditingStarted" | "onCellEditingStopped" | "onRowEditingStarted" | "onRowEditingStopped" | "onFilterOpened" | "onFilterChanged" | "onFilterModified" | "onChartCreated" | "onChartRangeSelectionChanged" | "onChartOptionsChanged" | "onChartDestroyed" | "onCellKeyDown" | "onCellKeyPress" | "onGridReady" | "onFirstDataRendered" | "onGridSizeChanged" | "onModelUpdated" | "onVirtualRowRemoved" | "onViewportChanged" | "onBodyScroll" | "onBodyScrollEnd" | "onDragStarted" | "onDragStopped" | "onPaginationChanged" | "onRowDragEnter" | "onRowDragMove" | "onRowDragLeave" | "onRowDragEnd" | "onColumnRowGroupChanged" | "onRowGroupOpened" | "onExpandOrCollapseAll" | "onPinnedRowDataChanged" | "onRowDataChanged" | "onRowDataUpdated" | "onAsyncTransactionsFlushed" | "onCellClicked" | "onCellDoubleClicked" | "onCellFocused" | "onCellMouseOver" | "onCellMouseOut" | "onCellMouseDown" | "onRowClicked" | "onRowDoubleClicked" | "onRowSelected" | "onSelectionChanged" | "onCellContextMenu" | "onRangeSelectionChanged" | "onSortChanged" | "onColumnRowGroupChangeRequest" | "onColumnPivotChangeRequest" | "onColumnValueChangeRequest" | "onColumnAggFuncChangeRequest")[];
    static getEventCallbacks(): string[];
    static copyAttributesToGridOptions(gridOptions: GridOptions | undefined, component: any, skipEventDeprecationCheck?: boolean): GridOptions;
    static getCallbackForEvent(eventName: string): string;
    static processOnChange(changes: any, gridOptions: GridOptions, api: GridApi, columnApi: ColumnApi): void;
    static toBoolean(value: any): boolean;
    static toNumber(value: any): number | undefined;
}
